blob: 9e76b0df7fc6166fd59f72fdeace59890f6419ce [file] [log] [blame]
garciadeblas16304ba2016-05-11 14:47:39 +02001#!/bin/bash
2
3##
4# Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5# This file is part of openmano
6# All Rights Reserved.
7#
8# Licensed under the Apache License, Version 2.0 (the "License"); you may
9# not use this file except in compliance with the License. You may obtain
10# a copy of the License at
11#
12# http://www.apache.org/licenses/LICENSE-2.0
13#
14# Unless required by applicable law or agreed to in writing, software
15# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17# License for the specific language governing permissions and limitations
18# under the License.
19#
20# For those usages not covered by the Apache License, Version 2.0 please
21# contact with: nfvlabs@tid.es
22##
23
tierno76841842016-09-27 09:18:28 +000024#ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
garciadeblas16304ba2016-05-11 14:47:39 +020025#Get needed packages, source code and configure to run openmano
26#Ask for database user and password if not provided
garciadeblas16304ba2016-05-11 14:47:39 +020027
28function usage(){
tiernoc50e5da2016-07-06 17:49:45 +020029 echo -e "usage: sudo $0 [OPTIONS]"
tierno45a52852016-08-26 14:39:42 +020030 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
tiernoc50e5da2016-07-06 17:49:45 +020032 echo -e " OPTIONS"
tierno45a52852016-08-26 14:39:42 +020033 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
garciadeblas89b3d842016-09-19 15:18:33 +020035 echo -e " -q --quiet: install in unattended mode"
tierno45a52852016-08-26 14:39:42 +020036 echo -e " -h --help: show this help"
37 echo -e " --develop: install last version for developers, and do not configure as a service"
tierno26777652016-11-15 17:33:13 +000038 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
39 echo -e " --force: makes idenpotent, delete previous installations folders if needed"
garciadeblas89b3d842016-09-19 15:18:33 +020040 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
tierno76841842016-09-27 09:18:28 +000041 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
garciadeblas16304ba2016-05-11 14:47:39 +020042}
43
44function install_packages(){
45 [ -x /usr/bin/apt-get ] && apt-get install -y $*
tiernoc50e5da2016-07-06 17:49:45 +020046 [ -x /usr/bin/yum ] && yum install -y $*
garciadeblas16304ba2016-05-11 14:47:39 +020047
48 #check properly installed
49 for PACKAGE in $*
50 do
51 PACKAGE_INSTALLED="no"
52 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
53 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
54 if [ "$PACKAGE_INSTALLED" = "no" ]
55 then
tiernoc50e5da2016-07-06 17:49:45 +020056 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
garciadeblas89b3d842016-09-19 15:18:33 +020057 exit 1
garciadeblas16304ba2016-05-11 14:47:39 +020058 fi
59 done
60}
61
garciadeblas89b3d842016-09-19 15:18:33 +020062function db_exists() {
63 RESULT=`mysqlshow --defaults-extra-file="$2" | grep -v Wildcard | grep -o $1`
64 if [ "$RESULT" == "$1" ]; then
65 echo " DB $1 exists"
66 return 0
67 fi
68 echo " DB $1 does not exist"
69 return 1
70}
71
tierno45a52852016-08-26 14:39:42 +020072GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
tiernoc50e5da2016-07-06 17:49:45 +020073DBUSER="root"
74DBPASSWD=""
75DBPASSWD_PARAM=""
76QUIET_MODE=""
tierno45a52852016-08-26 14:39:42 +020077DEVELOP=""
garciadeblas89b3d842016-09-19 15:18:33 +020078FORCEDB=""
tierno26777652016-11-15 17:33:13 +000079FORCE=""
garciadeblas89b3d842016-09-19 15:18:33 +020080NOCLONE=""
tierno76841842016-09-27 09:18:28 +000081NO_PACKAGES=""
tiernoc50e5da2016-07-06 17:49:45 +020082while getopts ":u:p:hiq-:" o; do
83 case "${o}" in
84 u)
85 export DBUSER="$OPTARG"
86 ;;
87 p)
88 export DBPASSWD="$OPTARG"
89 export DBPASSWD_PARAM="-p$OPTARG"
90 ;;
91 q)
92 export QUIET_MODE=yes
93 export DEBIAN_FRONTEND=noninteractive
94 ;;
95 h)
96 usage && exit 0
97 ;;
98 -)
99 [ "${OPTARG}" == "help" ] && usage && exit 0
tierno45a52852016-08-26 14:39:42 +0200100 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
garciadeblas89b3d842016-09-19 15:18:33 +0200101 [ "${OPTARG}" == "forcedb" ] && FORCEDB="y" && continue
tierno26777652016-11-15 17:33:13 +0000102 [ "${OPTARG}" == "force" ] && FORCEDB="y" && FORCE="y" && continue
garciadeblas89b3d842016-09-19 15:18:33 +0200103 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
tierno45a52852016-08-26 14:39:42 +0200104 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
tierno76841842016-09-27 09:18:28 +0000105 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
tiernoc50e5da2016-07-06 17:49:45 +0200106 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
107 exit 1
108 ;;
109 \?)
110 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
111 exit 1
112 ;;
113 :)
114 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
115 exit 1
116 ;;
117 *)
118 usage >&2
garciadeblas89b3d842016-09-19 15:18:33 +0200119 exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200120 ;;
121 esac
122done
garciadeblas16304ba2016-05-11 14:47:39 +0200123
tiernoc50e5da2016-07-06 17:49:45 +0200124#check root privileges and non a root user behind
garciadeblas89b3d842016-09-19 15:18:33 +0200125[ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200126if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
127then
128 [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK
129 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
130 export SUDO_USER=root
131fi
garciadeblas16304ba2016-05-11 14:47:39 +0200132
133#Discover Linux distribution
134#try redhat type
135[ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
136#if not assuming ubuntu type
137[ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
138if [ "$_DISTRO" == "Ubuntu" ]
139then
tierno45a52852016-08-26 14:39:42 +0200140 _RELEASE=$(lsb_release -rs)
141 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200142 then
tierno45a52852016-08-26 14:39:42 +0200143 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK
tiernoc50e5da2016-07-06 17:49:45 +0200144 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
tierno45a52852016-08-26 14:39:42 +0200145 _RELEASE = 14
garciadeblas16304ba2016-05-11 14:47:39 +0200146 fi
147elif [ "$_DISTRO" == "CentOS" ]
148then
149 _RELEASE="7"
150 if ! cat /etc/redhat-release | grep -q "7."
151 then
tiernoc50e5da2016-07-06 17:49:45 +0200152 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK
153 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200154 fi
155elif [ "$_DISTRO" == "Red" ]
156then
157 _RELEASE="7"
158 if ! cat /etc/redhat-release | grep -q "7."
159 then
tiernoc50e5da2016-07-06 17:49:45 +0200160 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK
161 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200162 fi
163else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
164 _DISTRO_DISCOVER=$_DISTRO
165 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
166 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
tiernoc50e5da2016-07-06 17:49:45 +0200167 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK
168 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200169fi
170
tierno26777652016-11-15 17:33:13 +0000171#check if installed as a service
172INSTALL_AS_A_SERVICE=""
173[[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
174#Next operations require knowing OPENMANO_BASEFOLDER
175if [[ -z "$NOCLONE" ]]; then
tiernoaa5832d2016-12-07 16:20:25 +0100176 if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then
177 OPENMANO_BASEFOLDER=__openmano__${RANDOM}
178 else
179 OPENMANO_BASEFOLDER="${PWD}/openmano"
180 fi
181 [[ -n "$FORCE" ]] && rm -rf $OPENMANO_BASEFOLDER #make idempotent
tierno26777652016-11-15 17:33:13 +0000182else
183 HERE=$(realpath $(dirname $0))
184 OPENMANO_BASEFOLDER=$(dirname $HERE)
185fi
garciadeblas16304ba2016-05-11 14:47:39 +0200186
187
tierno76841842016-09-27 09:18:28 +0000188if [[ -z "$NO_PACKAGES" ]]
189then
garciadeblas16304ba2016-05-11 14:47:39 +0200190echo '
191#################################################################
192##### UPDATE REPOSITORIES #####
193#################################################################'
194[ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
195
196[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
197[ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
198[ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
199 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
200[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
201
tierno76841842016-09-27 09:18:28 +0000202fi
garciadeblas16304ba2016-05-11 14:47:39 +0200203
tierno76841842016-09-27 09:18:28 +0000204if [[ -z "$NO_PACKAGES" ]]
205then
garciadeblas16304ba2016-05-11 14:47:39 +0200206echo '
207#################################################################
208##### INSTALL REQUIRED PACKAGES #####
209#################################################################'
210[ "$_DISTRO" == "Ubuntu" ] && install_packages "git screen wget mysql-server"
211[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git screen wget mariadb mariadb-server"
212
tiernoc50e5da2016-07-06 17:49:45 +0200213if [[ "$_DISTRO" == "Ubuntu" ]]
214then
215 #start services. By default CentOS does not start services
216 service mysql start >> /dev/null
217 # try to set admin password, ignore if fails
218 [[ -n $DBPASSWD ]] && mysqladmin -u $DBUSER -s password $DBPASSWD
219fi
220
garciadeblas16304ba2016-05-11 14:47:39 +0200221if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
222then
223 #start services. By default CentOS does not start services
224 service mariadb start
225 service httpd start
226 systemctl enable mariadb
227 systemctl enable httpd
228 read -e -p "Do you want to configure mariadb (recommended if not done before) (Y/n)" KK
229 [ "$KK" != "n" -a "$KK" != "no" ] && mysql_secure_installation
230
231 read -e -p "Do you want to set firewall to grant web access port 80,443 (Y/n)" KK
232 [ "$KK" != "n" -a "$KK" != "no" ] &&
233 firewall-cmd --permanent --zone=public --add-service=http &&
234 firewall-cmd --permanent --zone=public --add-service=https &&
235 firewall-cmd --reload
236fi
tierno76841842016-09-27 09:18:28 +0000237fi #[[ -z "$NO_PACKAGES" ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200238
239#check and ask for database user password. Must be done after database installation
tiernoc50e5da2016-07-06 17:49:45 +0200240if [[ -n $QUIET_MODE ]]
241then
242 echo -e "\nCheking database connection and ask for credentials"
garciadeblas89b3d842016-09-19 15:18:33 +0200243 while ! mysqladmin -s -u$DBUSER $DBPASSWD_PARAM status >/dev/null
tiernoc50e5da2016-07-06 17:49:45 +0200244 do
garciadeblas16304ba2016-05-11 14:47:39 +0200245 [ -n "$logintry" ] && echo -e "\nInvalid database credentials!!!. Try again (Ctrl+c to abort)"
246 [ -z "$logintry" ] && echo -e "\nProvide database credentials"
247 read -e -p "database user? ($DBUSER) " DBUSER_
248 [ -n "$DBUSER_" ] && DBUSER=$DBUSER_
249 read -e -s -p "database password? (Enter for not using password) " DBPASSWD_
tiernoc50e5da2016-07-06 17:49:45 +0200250 [ -n "$DBPASSWD_" ] && DBPASSWD="$DBPASSWD_" && DBPASSWD_PARAM="-p$DBPASSWD_"
251 [ -z "$DBPASSWD_" ] && DBPASSWD="" && DBPASSWD_PARAM=""
garciadeblas16304ba2016-05-11 14:47:39 +0200252 logintry="yes"
tiernoc50e5da2016-07-06 17:49:45 +0200253 done
254fi
garciadeblas16304ba2016-05-11 14:47:39 +0200255
tierno76841842016-09-27 09:18:28 +0000256if [[ -z "$NO_PACKAGES" ]]
257then
garciadeblas16304ba2016-05-11 14:47:39 +0200258echo '
259#################################################################
260##### INSTALL PYTHON PACKAGES #####
261#################################################################'
bayramovfe3f3c92016-10-04 07:53:41 +0400262[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip"
263[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip"
264
265#required for vmware connector TODO move that to separete opt in install script
266sudo pip install --upgrade pip
267sudo pip install pyvcloud
268sudo pip install progressbar
269sudo pip install prettytable
bhangarefda5f7c2017-01-12 23:50:34 -0800270sudo pip install pyvmomi
garciadeblas16304ba2016-05-11 14:47:39 +0200271
272#The only way to install python-bottle on Centos7 is with easy_install or pip
273[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
274
275#install openstack client needed for using openstack as a VIM
tierno93bffb42016-12-31 17:08:51 +0100276[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient"
277[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient #TODO revise if gcc python-pip is needed
tierno76841842016-09-27 09:18:28 +0000278fi #[[ -z "$NO_PACKAGES" ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200279
garciadeblas89b3d842016-09-19 15:18:33 +0200280if [[ -z $NOCLONE ]]; then
281 echo '
garciadeblas16304ba2016-05-11 14:47:39 +0200282#################################################################
283##### DOWNLOAD SOURCE #####
284#################################################################'
tierno26777652016-11-15 17:33:13 +0000285 su $SUDO_USER -c "git clone ${GIT_URL} ${OPENMANO_BASEFOLDER}"
286 su $SUDO_USER -c "cp ${OPENMANO_BASEFOLDER}/.gitignore-common ${OPENMANO_BASEFOLDER}/.gitignore"
tiernob1c42b62016-12-16 00:24:23 +0100287 [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} checkout tags/v1.0.2"
garciadeblas89b3d842016-09-19 15:18:33 +0200288fi
garciadeblas16304ba2016-05-11 14:47:39 +0200289
290echo '
291#################################################################
292##### CREATE DATABASE #####
293#################################################################'
garciadeblas89b3d842016-09-19 15:18:33 +0200294echo -e "\nCreating temporary file form MYSQL installation and initialization"
295TEMPFILE="$(mktemp -q --tmpdir "installopenmano.XXXXXX")"
garciadeblas4b3b4462016-09-27 11:16:14 +0200296trap 'rm -f "$TEMPFILE"' EXIT
garciadeblas89b3d842016-09-19 15:18:33 +0200297chmod 0600 "$TEMPFILE"
tierno26777652016-11-15 17:33:13 +0000298echo -e "[client]\n user='$DBUSER'\n password='$DBPASSWD'">"$TEMPFILE"
garciadeblas16304ba2016-05-11 14:47:39 +0200299
tierno12b1f742016-09-19 15:43:53 +0000300if db_exists "mano_db" $TEMPFILE ; then
garciadeblas89b3d842016-09-19 15:18:33 +0200301 if [[ -n $FORCEDB ]]; then
302 echo " Deleting previous database mano_db"
303 DBDELETEPARAM=""
304 [[ -n $QUIET_MODE ]] && DBDELETEPARAM="-f"
305 mysqladmin --defaults-extra-file=$TEMPFILE -s drop mano_db $DBDELETEPARAM || ! echo "Could not delete mano_db database" || exit 1
306 #echo "REVOKE ALL PRIVILEGES ON mano_db.* FROM 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
307 #echo "DELETE USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
308 mysqladmin --defaults-extra-file=$TEMPFILE -s create mano_db || ! echo "Error creating mano_db database" || exit 1
309 echo "DROP USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
310 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
311 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
312 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
313 else
314 echo "Database exists. Use option '--forcedb' to force the deletion of the existing one" && exit 1
315 fi
316else
tierno12b1f742016-09-19 15:43:53 +0000317 mysqladmin -u$DBUSER $DBPASSWD_PARAM -s create mano_db || ! echo "Error creating mano_db database" || exit 1
garciadeblas89b3d842016-09-19 15:18:33 +0200318 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
319 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
320 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
321fi
garciadeblas16304ba2016-05-11 14:47:39 +0200322
garciadeblas89b3d842016-09-19 15:18:33 +0200323
324echo '
325#################################################################
326##### INIT DATABASE #####
327#################################################################'
tierno26777652016-11-15 17:33:13 +0000328su $SUDO_USER -c "${OPENMANO_BASEFOLDER}/database_utils/init_mano_db.sh -u mano -p manopw -d mano_db" || ! echo "Failed while initializing database" || exit 1
garciadeblas89b3d842016-09-19 15:18:33 +0200329
garciadeblas16304ba2016-05-11 14:47:39 +0200330
331if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
332then
333 echo '
334#################################################################
335##### CONFIGURE firewalld #####
336#################################################################'
tiernoc50e5da2016-07-06 17:49:45 +0200337 KK=yes
338 [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK
garciadeblas16304ba2016-05-11 14:47:39 +0200339 if [ "$KK" != "n" -a "$KK" != "no" ]
340 then
341 #Creates a service file for openmano
342 echo '<?xml version="1.0" encoding="utf-8"?>
343<service>
344 <short>openmanod</short>
345 <description>openmanod service</description>
346 <port protocol="tcp" port="9090"/>
347</service>' > /etc/firewalld/services/openmanod.xml
348 #put proper permissions
349 pushd /etc/firewalld/services > /dev/null
350 restorecon openmanod.xml
351 chmod 640 openmanod.xml
352 popd > /dev/null
353 #Add the openmanod service to the default zone permanently and reload the firewall configuration
354 firewall-cmd --permanent --add-service=openmanod > /dev/null
355 firewall-cmd --reload > /dev/null
356 echo "done."
357 else
358 echo "skipping."
359 fi
360fi
361
362echo '
363#################################################################
364##### CONFIGURE OPENMANO CLIENT #####
365#################################################################'
tierno26777652016-11-15 17:33:13 +0000366#creates a link at ~/bin if not configured as a service
367if [[ -z "$INSTALL_AS_A_SERVICE" ]]
tiernoc50e5da2016-07-06 17:49:45 +0200368then
tierno26777652016-11-15 17:33:13 +0000369 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
370 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
371 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
372 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
tiernoaa5832d2016-12-07 16:20:25 +0100373 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/openmano' "'${HOME}/bin/openmano'
374 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report'
375 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh' "'${HOME}/bin/service-openmano'
tierno26777652016-11-15 17:33:13 +0000376
377 #insert /home/<user>/bin in the PATH
378 #skiped because normally this is done authomatically when ~/bin exist
379 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
380 #then
381 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
382 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
383 #fi
384 if [[ $SUDO_USER == root ]]
tiernoc50e5da2016-07-06 17:49:45 +0200385 then
tierno26777652016-11-15 17:33:13 +0000386 if ! echo $PATH | grep -q "${HOME}/bin"
387 then
388 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
389 fi
390 fi
391fi
garciadeblas16304ba2016-05-11 14:47:39 +0200392
393#configure arg-autocomplete for this user
394#in case of minimal instalation this package is not installed by default
395[[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
396#su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
397su $SUDO_USER -c 'activate-global-python-argcomplete --user'
tiernoc50e5da2016-07-06 17:49:45 +0200398if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200399then
400 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
tiernoc50e5da2016-07-06 17:49:45 +0200401 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200402fi
403
tierno45a52852016-08-26 14:39:42 +0200404
405
406
tierno26777652016-11-15 17:33:13 +0000407if [[ -n "$INSTALL_AS_A_SERVICE" ]]
tierno45a52852016-08-26 14:39:42 +0200408then
409echo '
410#################################################################
411##### CONFIGURE OPENMANO SERVICE #####
412#################################################################'
413
tiernoaa5832d2016-12-07 16:20:25 +0100414 ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"`
tierno26777652016-11-15 17:33:13 +0000415# rm -rf ${OPENMANO_BASEFOLDER}
tierno45a52852016-08-26 14:39:42 +0200416# alias service-openmano="service openmano"
417# echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
418
419 echo
tierno26777652016-11-15 17:33:13 +0000420 echo "Done! installed at /opt/openmano"
421 echo " Manage server with 'sudo service openmano start|stop|status|...' "
tierno45a52852016-08-26 14:39:42 +0200422
423
424else
425
426 echo
427 echo "Done! you may need to logout and login again for loading client configuration"
tierno26777652016-11-15 17:33:13 +0000428 echo " Run './${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh start' for starting openmano in a screen"
tierno45a52852016-08-26 14:39:42 +0200429
430fi
garciadeblas16304ba2016-05-11 14:47:39 +0200431
432
433